//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2022-08-12 14:07:20 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------

using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Application.Interfaces;
using IRaCIS.Core.Application.ViewModel;
using IRaCIS.Core.Infra.EFCore.Common;
using MassTransit;

namespace IRaCIS.Core.Application.Service
{
    /// <summary>
    /// 器官服务层
    /// </summary>	
    [ApiExplorerSettings(GroupName = "Reading")]
    public class OrganInfoService : BaseService, IOrganInfoService
    {

        private readonly IRepository<OrganInfo> _organInfoRepository;
        private readonly IRepository<OrganTrialInfo> _organTrialInfoRepository;
        private readonly IRepository<ReadingQuestionCriterionTrial> _readingQuestionCriterionTrial;
        private readonly IRepository<CriterionNidus> _criterionNidusRepository;

        public OrganInfoService(
            IRepository<OrganInfo> organInfoRepository,
            IRepository<OrganTrialInfo> organTrialInfoRepository,
            IRepository<ReadingQuestionCriterionTrial> readingQuestionCriterionTrial,
            IRepository<CriterionNidus> criterionNidusRepository
            )
        {
            _organInfoRepository = organInfoRepository;
            this._organTrialInfoRepository = organTrialInfoRepository;
            this._readingQuestionCriterionTrial = readingQuestionCriterionTrial;
            this._criterionNidusRepository = criterionNidusRepository;
        }

        /// <summary>
        /// 获取标准病灶列表
        /// </summary>
        /// <param name="inQuery"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<List<CriterionNidusView>> GetCriterionNidusList(CriterionNidusQuery inQuery)
        {

            var criterionNidusQueryable = _criterionNidusRepository
                .Where(x=>x.CriterionId== inQuery.CriterionId)
            .ProjectTo<CriterionNidusView>(_mapper.ConfigurationProvider);

            return await criterionNidusQueryable.ToListAsync();
        }

        /// <summary>
        /// 新增修改标准病灶列表
        /// </summary>
        /// <param name="addOrEditCriterionNidus"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IResponseOutput> AddOrUpdateCriterionNidus(CriterionNidusAddOrEdit addOrEditCriterionNidus)
        {
         
            var entity = await _criterionNidusRepository.InsertOrUpdateAsync(addOrEditCriterionNidus, true);

            return ResponseOutput.Ok(entity.Id.ToString());

        }

        /// <summary>
        /// 删除病灶列表
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        [HttpDelete("{id:guid}")]
        public async Task<IResponseOutput> DeleteCriterionNidus(Guid id)
        {
            var success = await _criterionNidusRepository.DeleteFromQueryAsync(t => t.Id == id, true);
            return ResponseOutput.Ok();
        }


        /// <summary>
        /// 获取系统器官信息
        /// </summary>
        /// <param name="inQuery"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<List<OrganInfoView>> GetOrganInfoList(OrganInfoQuery inQuery)
        {
            var organInfoQueryable = _organInfoRepository
         
               .WhereIf(inQuery.CriterionNidusId != null, x => x.CriterionNidusId == inQuery.CriterionNidusId)
            .ProjectTo<OrganInfoView>(_mapper.ConfigurationProvider);
            return await organInfoQueryable.ToListAsync();
        }


        /// <summary>
        /// 新增或修改系统器官数据
        /// </summary>
        /// <param name="addOrEditOrganInfo"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IResponseOutput> AddOrUpdateOrganInfo(OrganInfoAddOrEdit addOrEditOrganInfo)
        {
            var entity = await _organInfoRepository.InsertOrUpdateAsync(addOrEditOrganInfo, true);
            return ResponseOutput.Ok(entity.Id.ToString());
        }


        /// <summary>
        /// 删除系统器官
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        [HttpDelete("{Id:guid}")]
        public async Task<IResponseOutput> DeleteOrganInfo(Guid Id)
        {
            var success = await _organInfoRepository.DeleteFromQueryAsync(t => t.Id == Id, true);
            return ResponseOutput.Ok();
        }


        /// <summary>
        /// 批量添加项目器官
        /// </summary>
        /// <param name="inDto"></param>
        /// <returns></returns>
        public async Task<IResponseOutput> BatchAddTrialOrgan(BatchAddTrialOrganInDto inDto)
        {
            //await _organTrialInfoRepository.BatchDeleteNoTrackingAsync(t => t.TrialId==inDto.TrialId&&t.OrganType == inDto.OrganType);

            List<OrganTrialInfo> organTrialInfos = inDto.OrganIds.Select(x => new OrganTrialInfo()
            {
                OrganInfoId=x,
                TrialId=inDto.TrialId,
                //OrganType=inDto.OrganType,
            }).ToList();


            await _organTrialInfoRepository.AddRangeAsync(organTrialInfos);

            await _organInfoRepository.SaveChangesAsync();

            return ResponseOutput.Ok();
        }

        /// <summary>
        /// 删除系统器官
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        [HttpDelete("{Id:guid}")]
        public async Task<IResponseOutput> DeleteTrialOrganInfo(Guid Id)
        {
            var success = await _organTrialInfoRepository.DeleteFromQueryAsync(t => t.Id == Id, true);
            return ResponseOutput.Ok();
        }


        /// <summary>
        /// 获取项目器官信息
        /// </summary>
        /// <param name="inDto"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<List<GetTrialOrganListOutDto>> GetTrialOrganList(GetTrialOrganListInDto inDto)
        {
            var organInfoQueryable = from data in _organInfoRepository.WhereIf(inDto.CriterionNidusId !=null, x => x.CriterionNidusId == inDto.CriterionNidusId)
                                     join trialData in _organTrialInfoRepository.WhereIf(inDto.IsEnable != null, x => x.IsEnable == inDto.IsEnable)
                                     .Where(x => x.TrialId == inDto.TrialId)
                                     on data.Id equals trialData.OrganInfoId
                                     select new GetTrialOrganListOutDto()
                                     {
                                         Id = trialData.Id,
                                         Part = data.Part,
                                         TULAT = data.TULAT,
                                         TULOC = data.TULOC,
                                         Remark= data.Remark,
                                         CriterionNidusId = data.CriterionNidusId,
                                         IsEnable= trialData.IsEnable,
                                     };


            return await organInfoQueryable.ToListAsync();
        }



        /// <summary>
        /// 获取项目勾选器官信息
        /// </summary>
        /// <param name="inDto"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<List<GetTrialCheckOrganList>> GetTrialCheckOrganList(GetTrialOrganListInDto inDto)
        {
            var organInfoQueryable = from data in _organInfoRepository.WhereIf(inDto.CriterionNidusId != null, x => x.CriterionNidusId == inDto.CriterionNidusId)
                                     join trialData in _organTrialInfoRepository.WhereIf(inDto.IsEnable != null, x => x.IsEnable == inDto.IsEnable)
                                     .Where(x => x.TrialId == inDto.TrialId)
                                     on data.Id equals trialData.OrganInfoId into jtemp
                                     from leftjoin in jtemp.DefaultIfEmpty()
                                     select new GetTrialCheckOrganList()
                                     {
                                         Id = data.Id,
                                         Part = data.Part,
                                         TULAT = data.TULAT,
                                         TULOC = data.TULOC,
                                       
                                         IsCheckd= leftjoin!=null,
                                         Remark = data.Remark,
                                         CriterionNidusId = data.CriterionNidusId,
                                         IsEnable = leftjoin.IsEnable,

                                     };


            return await organInfoQueryable.ToListAsync();
        }

        /// <summary>
        /// 同步系统器官到项目
        /// </summary>
        /// <param name="inDto"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IResponseOutput> SynchronizeSystemOrganToTrial(SynchronizeSystemOrganToTrialInDto inDto)
        {
         
            var readingQuestionCriterionTrial = await _readingQuestionCriterionTrial.Where(x => x.TrialId == inDto.TrialId && x.IsConfirm).FirstOrDefaultAsync();

            if (readingQuestionCriterionTrial != null)
            {
                Guid trialCriterionId = default(Guid);

                trialCriterionId = readingQuestionCriterionTrial.Id;
                if (inDto.SystemCriterionId == null)
                {
                    inDto.SystemCriterionId = readingQuestionCriterionTrial.ReadingQuestionCriterionSystemId;
                }
                await _criterionNidusRepository.BatchDeleteNoTrackingAsync(x => x.CriterionId == trialCriterionId);
                List<CriterionNidusData> criterionNidusList = await _criterionNidusRepository.Where(x => x.CriterionId == inDto.SystemCriterionId).Select(x => new CriterionNidusData()
                {
                    Id = NewId.NextGuid(),
                    CriterionId = trialCriterionId,
                    NidusType = x.NidusType,
                    NidusTypeCN = x.NidusTypeCN,
                    OriginalId = x.Id,
                }).ToListAsync();

                await _criterionNidusRepository.AddRangeAsync(criterionNidusList);
                await _organTrialInfoRepository.BatchDeleteNoTrackingAsync(x => x.TrialId == inDto.TrialId);
                var originalIds = criterionNidusList.Select(x => x.OriginalId).Distinct().ToList();
                List<OrganTrialInfo> organTrialInfoList = await _organInfoRepository.Where(x => originalIds.Contains(x.CriterionNidusId)).Select(x => new OrganTrialInfo()
                {
                    CriterionNidusId = x.CriterionNidusId,
                    Id = NewId.NextGuid(),
                    IsEnable = true,
                    OrganInfoId = x.Id,
                    TrialId = inDto.TrialId,
                }).ToListAsync();

                organTrialInfoList.ForEach(x =>
                {

                    x.OrganInfoId = criterionNidusList.Where(y => y.OriginalId == x.OrganInfoId).Select(x => x.Id).FirstOrDefault();
                });


                await _organTrialInfoRepository.AddRangeAsync(organTrialInfoList);
                await _readingQuestionCriterionTrial.UpdatePartialFromQueryAsync(trialCriterionId,x=> new ReadingQuestionCriterionTrial() { 
                SynchronizeOriginalTime=DateTime.Now
                });
                await _organTrialInfoRepository.SaveChangesAsync();
            }

          

            return ResponseOutput.Ok();

        }


      

        /// <summary>
        /// 设置项目器官是否生效
        /// </summary>
        /// <param name="inDto"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IResponseOutput> SetOrganIsEnable(SetOrganIsEnableInDto inDto)
        {
            await _organTrialInfoRepository.UpdatePartialFromQueryAsync(x => inDto.Ids.Contains(x.Id), x => new OrganTrialInfo()
            {
                IsEnable=inDto.IsEnable
            });

            await _organTrialInfoRepository.SaveChangesAsync();

            return ResponseOutput.Ok();
        }

    }
}
